Lattice Builder Manual Software Package for Constructing Rank-1 Lattices

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Friends Modules Pages
Public Types | Public Member Functions | List of all members
LatBuilder::Functor::MinElement< T > Struct Template Reference

Minimum element functor. More...

`#include <MinElement.h>`

## Public Types
typedef boost::signals2::signal< void()> | OnStart
typedef boost::signals2::signal< void()> | OnStop
typedef boost::signals2::signal< void(const T &)> | OnMinUpdated
typedef boost::signals2::signal< bool(const T &), Functor::AllOf > | OnElementVisited

## Public Member Functions
| MinElement ()
| Constructor.
template<typename ForwardIterator >
ForwardIterator | operator() (ForwardIterator first, ForwardIterator last) const
| Returns an iterator pointing to the minimum element between `first` and `last` (exclusively). More...
OnStart & | onStart ()
| Start signal. More...
const OnStart & | onStart () const
OnStop & | onStop ()
| Stop signal. More...
const OnStop & | onStop () const
const OnMinUpdated & | onMinUpdated () const
| Minimum-updated signal. More...
OnMinUpdated & | onMinUpdated ()
OnElementVisited & | onElementVisited ()
| Element-visited updated signal. More...
const OnElementVisited & | onElementVisited () const

## Detailed Description

### template<typename T>
struct LatBuilder::Functor::MinElement< T >

Minimum element functor.

Re-implementation of std::min_element that emits a MinElement::onMinUpdated() signal when the current minimum value is updated.

## Member Function Documentation

template<typename T>

OnElementVisited& LatBuilder::Functor::MinElement< T >::onElementVisited | ( |  | ) |
| inline

Element-visited updated signal.

Emitted after an element is visited.

Referenced by LatBuilder::Functor::MinElement< Real >::operator()().

template<typename T>

const OnMinUpdated& LatBuilder::Functor::MinElement< T >::onMinUpdated | ( |  | ) | const
| inline

Minimum-updated signal.

Emitted when the current minimum value has been updated.

Referenced by LatBuilder::Functor::MinElement< Real >::operator()().

template<typename T>

OnStart& LatBuilder::Functor::MinElement< T >::onStart | ( |  | ) |
| inline

Start signal.

Emitted before the search begins.

Referenced by LatBuilder::Functor::MinElement< Real >::operator()().

template<typename T>

OnStop& LatBuilder::Functor::MinElement< T >::onStop | ( |  | ) |
| inline

Stop signal.

Emitted after the search ends.

Referenced by LatBuilder::Functor::MinElement< Real >::operator()().

template<typename T>
template<typename ForwardIterator >

ForwardIterator LatBuilder::Functor::MinElement< T >::operator() | ( | ForwardIterator | first,
|  | ForwardIterator | last
| ) |  | const
| inline

Returns an iterator pointing to the minimum element between `first` and `last` (exclusively).

A start and a stop signals are emitted before the search begins and after it ends, respectively. A minimum-updated signal is emitted when the minimum is updated. An element-visited signal is emitted after an element has been visited.

The documentation for this struct was generated from the following file:

- latbuilder/include/latbuilder/Functor/MinElement.h